job_specs: add wireguard perf tests to regression
[csit.git] / resources / libraries / bash / entry / check / line.sh
1 # Copyright (c) 2021 Cisco and/or its affiliates.
2 # Licensed under the Apache License, Version 2.0 (the "License");
3 # you may not use this file except in compliance with the License.
4 # You may obtain a copy of the License at:
5 #
6 #     http://www.apache.org/licenses/LICENSE-2.0
7 #
8 # Unless required by applicable law or agreed to in writing, software
9 # distributed under the License is distributed on an "AS IS" BASIS,
10 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
11 # See the License for the specific language governing permissions and
12 # limitations under the License.
13
14 set -exuo pipefail
15
16 # This file should be executed from tox, as the assumend working directory
17 # is different from where this file is located.
18 # This file does not have executable flag nor shebang,
19 # to dissuade non-tox callers.
20
21 # This script runs a grep-based command and fails if it detects any lines
22 # longer than 80 characters.
23 # The grep output stored to lines.log (overwriting).
24
25 # "set -eu" handles failures from the following two lines.
26 BASH_CHECKS_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
27 BASH_FUNCTION_DIR="$(readlink -e "${BASH_CHECKS_DIR}/../../function")"
28 source "${BASH_FUNCTION_DIR}/common.sh" || {
29     echo "Source failed." >&2
30     exit 1
31 }
32
33 # Directory docs contains too many wide formatted tables.
34 # .txt contains lines with wide URLs.
35 piped_command='set -exuo pipefail && grep -rn ".\{81\}" "resources/" "tests/"'
36 piped_command+=' | fgrep -v .svg | fgrep -v .txt | tee "lines.log" | wc -l'
37 # TODO: The greps "fail" if no long line remains. Fix that if it ever happens.
38 lines="$(bash -c "${piped_command}")" || die
39 if [ "${lines}" != "0" ]; then
40     # TODO: Decide which text goes to stdout and which to stderr.
41     warn "Long lines detected: ${lines}"
42     ## TODO: Enable when output size does more good than harm.
43     # cat "lines.log" >&2
44     warn
45     warn "Line length checker: FAIL"
46     exit 1
47 fi
48
49 warn
50 warn "Line length checker: PASS"